Estimate the effort to create matrix web client; create minimum sample
Description

History

#1 - 04/23/2020 05:14 PM - Ahmed Bilal

Matrix API documentations can be found at https://matrix.org/docs/api/client-server/

Note: Deleting a room is probably not supported using Matrix API.

#2 - 04/23/2020 05:14 PM - Ahmed Bilal

Waiting for login facility to get fixed in our Matrix instance.
#3 - 04/23/2020 08:30 PM - Timothée Floure

¢ You can make use of this: https://github.com/matrix-org/matrix-js-sdk/ (it backs matrix-react-sdk/riot-web).

¢ Right now Matrix has a lot of incomplete clients: https:/matrix.org/clients/
- It's kind of an issue: lot of yet-to-be amazing clients, which do not support everything (i.e. E2EE, communities). People try a build new things
instead of improving existing ones. (FYI)

#4 - 04/23/2020 09:16 PM - Nico Schottelius

A note on design: as we are often saying "mattermost looks nicer" | would suggest that we create a client that uses the Ul of mattermost, but the sdk
of matrix. This way we would combine the best of both worlds and in the best case don't need to re-invent the wheel.

One tiny thing I'd add to the mattermost design is to use the displayname as the username, but append in a slightly smaller font the real username:
Nico Schottelius (@nico:ungleich.ch) (part in brackets smaller, maybe more muted).

Otherwise we can stay for 99.99% on the mattermost design
#5 - 04/25/2020 07:46 PM - Ahmed Bilal

¢ | think it wouldn't be the case that we can easily use mattermost's things especially JavaScript components (
https://github.com/mattermost/mattermost-webapp/tree/master/components) in our Riot web app.

Although, we may be able to use the CSS (https:/github.com/mattermost/mattermost-webapp/tree/master/sass)

We can also just use bootstrap or some similar Ul framework.

We need to use some frontend framework for easier manipulation of DOM. See VueJS (It is easier one and adoptions is increasing day by day).
Don't know yet whether we can use the matrix-js-sdk (https:/github.com/matrix-org/matrix-js-sdk/) for all use cases e.g | don't see any
login/logout/signup flows as it was mentioned in the http API document (https:/matrix.org/docs/api/client-server/#/). Anyway, we can use both.
Mattermost is very polished and to come closer to it in functionality and stability would be quite a feat.

| think it would take serious amount of time to make it more usable than current Riot app which might be not a very good idea in current situation.

Not Completed Yet. | want to take a look at Riot Web to check whether we can fork it and improve it (by replacing the Ul)) *

#6 - 04/27/2020 01:52 PM - Nico Schottelius

Can you complete the estimate these days?

#7 - 04/29/2020 04:56 PM - Ahmed Bilal

Nico, | am confused about the estimate because it is frontend work and | didn't have much experience on frontend. But, it wouldn't be small effort. |
think it would take > 1 month to even have a usable frontend client not taking into consideration the pain points observed after actually running it in
production.
#8 - 04/29/2020 05:58 PM - Nico Schottelius

- Subject changed from Estimate the effort to create matrix web client to Estimate the effort to create matrix web client; create minimum sample

Ahmed Bilal wrote:

Nico, | am confused about the estimate because it is frontend work and | didn't have much experience on frontend. But, it wouldn't be small
effort. | think it would take > 1 month to even have a usable frontend client not taking into consideration the pain points observed after actually
running it in production.

Can you create a bootstrap / vue.js based sample that has only the following features:

e Can login / authenticate
¢ Can show messages of 1 room (room name can be hardcoded, no selection necessary, use #matrix:ungleich.ch
¢ No posting support necessary
e Deploy it on staticweb.ungleich.ch, use the domain name umatrix.ungleich.ch
o Ping Timothee for help where needed
¢ Keep me updated daily on progress/hours spent

#9 - 04/30/2020 07:44 AM - Ahmed Bilal
Aye Aye Captain :)

#10 - 12/01/2020 02:49 PM - Ahmed Bilal
- Assignee deleted (Ahmed Bilal)

#11 - 01/02/2024 01:56 PM - Nico Schottelius

- Status changed from New to Rejected
